<?php
include_once 'config.php' ;

$device = (int) getParam('device', $_GET, 0) ;
$sync 	= (int) getParam('sync', $_GET, -1) ;

/*
ALTER TABLE  `photocabine_cabines` ADD  `standby` INT NOT NULL ;
ALTER TABLE  `photocabine_config_alerts` ADD  `type` VARCHAR( 20 ) NOT NULL AFTER  `device` ;
ALTER TABLE  `photocabine_config_alerts` CHANGE  `nb`  `param` INT( 11 ) NOT NULL ;
*/

$sql = 'SELECT * FROM photocabine_cabines WHERE id_cabine = ' . $device ;
$cabine = $db->select($sql) ;

if($cabine)
{
	$nb_photos = (int) getParam('nb_photos', $_GET, 0) ;
	
	$data =  array('date_ping' => date('Y-m-d H:i:s')) ;
	if($nb_photos >= 0) $data['nb_photos'] = $nb_photos ;
	if($sync) $data['date_sync'] = date('Y-m-d H:i:s') ;
	
	if (array_key_exists('standby', $_GET))
	{
		$standby = (int) getParam('standby', $_GET, 0) ;
		$data['standby'] = $standby ;
	}
	
	// Printer
	if (array_key_exists('printer_state', $_GET))
	{
		$data['printer_state'] = $_GET['printer_state'] ;
	}
	
	$bSendPaperAlert = false ;
	if (array_key_exists('printer_photos_remaining', $_GET))
	{
		$nb_photos_last = $_GET['printer_photos_remaining'] ;
		$data['printer_photos_remaining'] = $nb_photos_last ;
		
		if($nb_photos_last <= 10 && $cabine->has_sent_paperalert != 1)
		{
			$bSendPaperAlert = true ;
			
			$data['has_sent_paperalert'] = 1 ;
		}
		
		if ($nb_photos_last > 10 && $cabine->has_sent_paperalert == 1)
		{
			$data['has_sent_paperalert'] = 0 ;
		}
	}
	
	$db->update('photocabine_cabines', $data, 'id_cabine = ' . $device) ;
	
	$sql = 'SELECT COUNT(*) nb FROM phocabine_photos WHERE sync > 1 AND config = "' . $cabine->config . '" AND device = ' .  $cabine->id_cabine ;
	$total = $db->select($sql)->nb ;
	
	// Paper
	//if ($total + $nb_photos  >= 390)
	if($bSendPaperAlert)
	{
		/*$alert = $db->select('SELECT * FROM photocabine_config_alerts WHERE config = "' . $cabine->config . '" AND device = ' .  $cabine->id_cabine .  ' AND type = "paper"') ;
		if (!$alert)
		{*/
			$data = array() ;
			$data['config'] = $cabine->config ;
			$data['device'] = $cabine->id_cabine ;
			$data['type'] 	= 'paper' ;
			$data['param']	= $total + $nb_photos ;
			$data['date'] 	= date('Y-m-d H:i:s') ;
		
			$db->insert('photocabine_config_alerts', $data) ;
		//}
	}
	
	// Memory Bug
	if (array_key_exists('memory_bug', $_GET))
	{
		$data = array() ;
		$data['config'] = $cabine->config ;
		$data['device'] = $cabine->id_cabine ;
		$data['type'] 	= 'memory_bug' ;
		$data['date'] 	= date('Y-m-d H:i:s') ;
		
		$db->insert('photocabine_config_alerts', $data) ;
	}

	// Webcam Bug
	if (array_key_exists('webcam_bug', $_GET))
	{
		$data = array() ;
		$data['config'] = $cabine->config ;
		$data['device'] = $cabine->id_cabine ;
		$data['type'] 	= 'webcam_bug' ;
		$data['date'] 	= date('Y-m-d H:i:s') ;
		
		$db->insert('photocabine_config_alerts', $data) ;
	}
?>
<xml>
	<cabine><?php echo $device ; ?></cabine>
	<config>config_<?php echo $device ; ?>.xml</config>
	<checksum_config><?php echo  md5_file(getXmlFile('config_' . $device . '.xml')) ; ?></checksum_config>
	<checksum_photo><?php echo  md5_file('../photo.swf') ; ?></checksum_photo>
	<checksum_video><?php echo  md5_file('../video.swf') ; ?></checksum_video>
	<checksum_selector><?php echo  md5_file('../selector.swf') ; ?></checksum_selector>
	<checksum_selfie><?php echo  md5_file('../selfie.swf') ; ?></checksum_selfie>
</xml>
<?php
}else{
?>
<xml>
	<cabine>0</cabine>
</xml>
<?php } ?>
