<?php
include_once 'config.php' ;
define('UPDATEDBG', false);
$bUpdated = false ;
set_time_limit(0);
$bServerReachable = is_server_reachable() ;
if($bServerReachable)
{
	$base_online = SITE ;
	$base_locale = dirname(dirname(__FILE__)) . '/' ;

	$infos = @simplexml_load_file($base_online . 'scripts/cabine.php?device=' . DEVICE_ID) ;

	//var_dump($infos) ;

	if ($infos && $infos->config && $infos->checksum_config)
	{
		$bNeedUpdateConfig 	= has_changedChecksum($base_locale . 'xml/config.xml', $infos->checksum_config) ;
		// also consider to update table photocabine_status if it is empty
		$sql = 'SELECT * from photocabine_status ORDER by date desc LIMIT 0, 1';
		$lines=$db->select($sql);
		if (! $lines){ //empty?
			$bNeedUpdateConfig |= true;
		}

		//var_dump($bNeedUpdateConfig);
		//$bNeedUpdateConfig = true ;
		$bNeedUpdate = $bNeedUpdateConfig;

		if ($bNeedUpdate)
		{
			$aFilesToDonwload = array() ;

			if ($bNeedUpdateConfig) array_push($aFilesToDonwload, 'xml/' . $infos->config) ;

			while (count($aFilesToDonwload))
			{
				$file = array_pop($aFilesToDonwload) ;

				downloadFile($base_online . $file . '?time=' . time(), $base_locale . $file) ;

				if (substr($file, -3, 3) == 'xml')
				{
					$oXML = simplexml_load_file($base_locale . $file);

					foreach ($oXML->children() as $child)
					{
						foreach ($child->children() as $node)
						{
							$filename = $node-> __toString() ;
							if ($node['ressource'] && $filename && has_changedChecksum($base_locale . $filename, $node['checksum']))
							{
								array_push($aFilesToDonwload, $filename) ;
							}else{
								foreach ($node->children() as $node2)
								{
									$filename = $node2-> __toString() ;
									if ($node2['ressource'] && $filename && has_changedChecksum($base_locale . $filename, $node2['checksum']))
									{
										array_push($aFilesToDonwload, $filename) ;
									}else{
										foreach ($node2->children() as $node3)
										{
											$filename = $node3-> __toString() ;
											if ($node3['ressource'] && $filename && has_changedChecksum($base_locale . $filename, $node3['checksum']))
											{
												array_push($aFilesToDonwload, $filename) ;
											}
											else {
												foreach ($node3->children() as $node4)
												{
													$filename = $node4-> __toString() ;
													if ($node4['ressource'] && $filename && has_changedChecksum($base_locale . $filename, $node4['checksum']))
													{
														array_push($aFilesToDonwload, $filename) ;
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
			$oConfigXml = loadConfig('xml/config.xml') ;
			if ($bNeedUpdateConfig)
			{
				copy($base_locale . 'xml/' . $infos->config, $base_locale . 'xml/config.xml') ;
				$oConfigXml = loadConfig('xml/config.xml') ;
				dbg(UPDATEDBG, "got new config xml id: " . $oConfigXml->id);
				
				//added for double mode
				copy($base_locale . 'xml/config.xml', $base_locale . 'xml/' . $oConfigXml->id . '.xml') ;
				//

				//unlink($base_locale . 'xml/' . $infos->config) ;
			}

			file_get_contents(SITE . 'scripts/cabine.php?device=' . DEVICE_ID . '&sync=1') ;
			dbg(UPDATEDBG, "finally config xml id: " . $oConfigXml->id);
			// update status
			$data = array();
			$data['date'] = date('Y-m-d H:i:s');
			$data['config'] = $oConfigXml->id;
			$data['device'] = DEVICE_ID;
			$data['needs_reboot']  = 0;
			if ($data['config'] !==  null ) {
				$data['needs_reboot'] = 1;
			}
			$db->insert('photocabine_status', $data);
			$bUpdated = true ;
		}
	}
}

if(array_key_exists('ajax', $_GET))
{
	echo $bUpdated ? 'OK' : 'NOT' ;
}
//var_dump($bUpdated) ;
